//*******************************************
// Copyright (c) 1998 by Warren Ward.
// Permission is granted to use this source
// code as long as this copyright notice
// appears in all source files that now
// include it.
//*******************************************

#ifndef     _CCryptor_H
#define     _CCryptor_H

class CCryptor
    {
    //
    // Properties.
    //
    protected:
        CString             m_Key;
        const unsigned long     m_Mask_A;
        const unsigned long     m_Mask_B;
        const unsigned long     m_Mask_C;
        const unsigned long     m_Rot0_A;
        const unsigned long     m_Rot0_B;
        const unsigned long     m_Rot0_C;
        const unsigned long     m_Rot1_A;
        const unsigned long     m_Rot1_B;
        const unsigned long     m_Rot1_C;

    // Standard methods.
    public:
        CCryptor();
        ~CCryptor();

    // Class interface.
    public:
        unsigned long           m_LFSR_A;
        unsigned long           m_LFSR_B;
        unsigned long           m_LFSR_C;
        void    Set_Key
                ( const CString & Key );
        void    Set_Key
                ( unsigned long Key1,unsigned long Key2,unsigned long Key3 );
        void    Transform_Char
                ( char * Target );
        void    Transform_String
                ( 
                const CString & Key, 
                CString & Target 
                );
    };

#endif  //      _CCryptor_H

